## modsecurity 3.0.3

=== test/benchmark/owasp-v2/util/integration/requirements.txt ===
pytest>=2.9.1

## modsecurity 3.0.2

=== debian/changelog ===
modsecurity (3.0.2-1) unstable; urgency=medium

  * Initial release (Closes: #909025)

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Mon, 17 Sep 2018 13:16:27 +0200

=== debian/control ===
Source: modsecurity
Priority: optional
Maintainer: Alberto Gonzalez Iniesta <agi@inittab.org>
Build-Depends: debhelper (>= 11), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre++-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev
Standards-Version: 4.2.1
Section: libs
Homepage: https://www.modsecurity.org/
#Vcs-Browser: https://salsa.debian.org/debian/modsecurity
#Vcs-Git: https://salsa.debian.org/debian/modsecurity.git

Package: libmodsecurity-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmodsecurity3 (= ${binary:Version}), ${misc:Depends}
Description: ModSecurity v3 library component (development files)
 Libmodsecurity is one component of the ModSecurity v3 project. The library
 codebase serves as an interface to ModSecurity Connectors taking in web
 traffic and applying traditional ModSecurity processing. In general, it
 provides the capability to load/interpret rules written in the ModSecurity
 SecRules format and apply them to HTTP content provided by your application
 via Connectors.
 .
 This package includes the development support files.

Package: libmodsecurity3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ModSecurity v3 library component
 Libmodsecurity is one component of the ModSecurity v3 project. The library
 codebase serves as an interface to ModSecurity Connectors taking in web
 traffic and applying traditional ModSecurity processing. In general, it
 provides the capability to load/interpret rules written in the ModSecurity
 SecRules format and apply them to HTTP content provided by your application
 via Connectors.

## modsecurity 3.0.3

=== debian/changelog ===
modsecurity (3.0.3-1) unstable; urgency=medium

  [ Ervin Hegedüs ]
  * New upstream version 3.0.3
  * Remove from debian/rules: Export TERM var required for test case.
  * Fix FTBFS (Closes: #911209):
    - Add upstream patch to avoid to use ENV:TERM in the regression tests
    - Add upstream patch to fix inet addr handling on 64 bit big endian
      systems
  * Add pkg-config to dependency list in d/control for make check in sbuild
  * Add <airween@gmail.com> to Uploaders

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Wed, 12 Dec 2018 08:17:40 +0100

modsecurity (3.0.2-2) UNRELEASED; urgency=medium

  * debian/copyright: Updated with all copyrights/licenses (Closes: #911153)
  * debian/patches: Add disable-network-dependent-tests.patch

  [ Ervin Hegedüs ]
  * debian/rules: Export TERM var required for test case.

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Mon, 26 Nov 2018 22:30:05 +0100

## modsecurity 3.0.3.1

=== debian/changelog ===
modsecurity (3.0.3.1-1+deb10u2+dde) unstable; urgency=medium

  * update

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Tue, 06 Jul 2021 10:12:38 +0800

modsecurity (3.0.3.1-1+deb10u2+dde) buster-security; urgency=medium

  * Non-maintainer upload.
  * Update version.

 -- wangpei <wangpei@uniontech.com>  Wed, 30 Jun 2021 14:31:23 +0800

modsecurity (3.0.3-1+deb10u2) buster-security; urgency=medium

  * Add patch by Ervin Hegedüs to fix CVE-2020-15598.

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Wed, 16 Sep 2020 13:04:37 +0200

modsecurity (3.0.3-1+deb10u1) buster; urgency=medium

  * Fixes CVE-2019-19886 (Closes: #949682)

 -- Ervin Hegedus <airween@gmail.com>  Tue, 21 Jan 2020 21:52:59 +0000

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: modsecurity
 Priority: optional
 Maintainer: Alberto Gonzalez Iniesta <agi@inittab.org>
-Build-Depends: debhelper (>= 11), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre++-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev
+Build-Depends: debhelper (>= 11), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre3-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev, pkg-config
 Standards-Version: 4.2.1
 Section: libs
+Uploaders: Ervin Hegedus <airween@gmail.com>
 Homepage: https://www.modsecurity.org/
-#Vcs-Browser: https://salsa.debian.org/debian/modsecurity
-#Vcs-Git: https://salsa.debian.org/debian/modsecurity.git
+Vcs-Browser: https://salsa.debian.org/agi/modsecurity
+Vcs-Git: https://salsa.debian.org/agi/modsecurity.git
 
 Package: libmodsecurity-dev
 Section: libdevel

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# move modsec-rules-check (lib debugging/testing tool) to libexec to avoid
# an extra package while keeping the library package multiarch
CONFIGURE_EXTRA_FLAGS += --bindir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)/libexec

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_EXTRA_FLAGS)

override_dh_auto_install:
	dh_auto_install
	# clean dependency_libs in .la files (Policy 10.2)
	sed -i "/dependency_libs/ s/'.*'/''/" $$(find debian/tmp/ -name '*.la')

## modsecurity 3.0.4

=== debian/changelog ===
modsecurity (3.0.4-2) unstable; urgency=high

  * Added patch: rx_op_remove_g_modif.patch. Fixes CVE-2020-15598

 -- Ervin Hegedüs <airween@gmail.com>  Mon, 14 Sep 2020 12:43:20 +0200

modsecurity (3.0.4-1) unstable; urgency=medium

  [ Ervin Hegedüs ]
  * New upstream version 3.0.4. Fixes CVE-2019-19886
  * Remove setenv_term_avoid.patch, upstream contains the fix
  * Remove bigendian_fix.patch, upstream contains the fix
  * Bump Standards-Version to 4.4.1
    - removed Vcs-Browser field from d/control

 -- Ervin Hegedus <airween@gmail.com>  Thu, 16 Jan 2020 09:52:23 +0100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,10 @@
 Priority: optional
 Maintainer: Alberto Gonzalez Iniesta <agi@inittab.org>
 Build-Depends: debhelper (>= 11), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre3-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev, pkg-config
-Standards-Version: 4.2.1
+Standards-Version: 4.4.1
 Section: libs
 Uploaders: Ervin Hegedus <airween@gmail.com>
 Homepage: https://www.modsecurity.org/
-Vcs-Browser: https://salsa.debian.org/agi/modsecurity
 Vcs-Git: https://salsa.debian.org/agi/modsecurity.git
 
 Package: libmodsecurity-dev

## modsecurity 3.0.6

=== debian/changelog ===
modsecurity (3.0.6-1) unstable; urgency=medium

  * Team upload
  * New upstream version
  * Fixes CVE-2021-42717
  * Removed rx_op_remove_g_modif.patch; upstream contains it
  * Bump compat version to 13
  * Bump Standards-Version to 4.6.0
  * Added modsecurity.pc to d/libmodsecurity-dev.install

 -- Ervin Hegedus <airween@gmail.com>  Wed, 24 Nov 2021 14:25:11 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: modsecurity
 Priority: optional
 Maintainer: Alberto Gonzalez Iniesta <agi@inittab.org>
-Build-Depends: debhelper (>= 11), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre3-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev, pkg-config
-Standards-Version: 4.4.1
+Build-Depends: debhelper (>= 13), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre3-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev, pkg-config
+Standards-Version: 4.6.0
 Section: libs
 Uploaders: Ervin Hegedus <airween@gmail.com>
 Homepage: https://www.modsecurity.org/

## modsecurity 3.0.8

=== debian/changelog ===
modsecurity (3.0.8-1) unstable; urgency=medium

  * New upstream version
  * Bump Standards-Version to 4.6.1

 -- Ervin Hegedus <airween@gmail.com>  Fri, 09 Sep 2022 14:05:02 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Alberto Gonzalez Iniesta <agi@inittab.org>
 Build-Depends: debhelper (>= 13), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre3-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev, pkg-config
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Section: libs
 Uploaders: Ervin Hegedus <airween@gmail.com>
 Homepage: https://www.modsecurity.org/

## modsecurity 3.0.9

=== others/libinjection/python/Makefile ===

all: build
#
#

build: copy libinjection/libinjection_wrap.c
	rm -f libinjection.py libinjection.pyc
	python setup.py --verbose build --force

install: build
	sudo python setup.py --verbose install

test-unit: build words.py
	python setup.py build_ext --inplace
	PYTHON_PATH='.' nosetests -v --with-xunit test_driver.py

.PHONY: test
test: test-unit

.PHONY: speed
speed:
	./speedtest.py


words.py: Makefile json2python.py ../src/sqlparse_data.json
	./json2python.py < ../src/sqlparse_data.json > words.py


libinjection/libinjection_wrap.c: libinjection/libinjection.i libinjection/libinjection.h libinjection/libinjection_sqli.h
	swig -version
	swig -python -builtin -Wall -Wextra libinjection/libinjection.i


copy:
	cp ../src/libinjection*.h ../src/libinjection*.c libinjection/

.PHONY: copy

libinjection.so: copy
	gcc -std=c99 -Wall -Werror -fpic -c libinjection/libinjection_sqli.c
	gcc -std=c99 -Wall -Werror -fpic -c libinjection/libinjection_xss.c
	gcc -std=c99 -Wall -Werror -fpic -c libinjection/libinjection_html5.c
	gcc -dynamiclib -shared -o libinjection.so libinjection_sqli.o libinjection_xss.o libinjection_html5.o

clean:
	@rm -rf build dist
	@rm -f *.pyc *~ *.so *.o
	@rm -f nosetests.xml
	@rm -f words.py
	@rm -f libinjection/*~ libinjection/*.pyc
	@rm -f libinjection/libinjection.h libinjection/libinjection_sqli.h libinjection/libinjection_sqli.c libinjection/libinjection_sqli_data.h
	@rm -f libinjection/libinjection_wrap.c libinjection/libinjection.py

=== debian/changelog ===
modsecurity (3.0.9-1+deb12u1) bookworm; urgency=medium

  * Applied upstream patch to fix DoS.
    CVE-2023-38285 (Closes: #1042475)

 -- Ervin Hegedüs <airween@gmail.com>  Mon, 25 Sep 2023 14:43:11 +0200

modsecurity (3.0.9-1) unstable; urgency=medium

  * New upstream version.
    Fixes DoS CVE-2023-28882. (Closes: #1035083)
  * Removed patches/pcrem4.patch, applied upstream.

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Tue, 25 Apr 2023 11:49:24 +0200

modsecurity (3.0.8-3) unstable; urgency=medium

  * New patch from Tobias Frost to fix FTBFS. (Closes: #1034760)

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Mon, 24 Apr 2023 16:52:16 +0200

modsecurity (3.0.8-2) unstable; urgency=medium

  * Team upload
  * Switched from old PCRE to PCRE2
    https://lists.debian.org/debian-devel/2021/11/msg00176.html
  * Add lintian override for source missing of test HTML file
    [others/libinjection/misc/base.html]

 -- Ervin Hegedüs <airween@gmail.com>  Sun, 12 Mar 2023 17:35:53 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: modsecurity
 Priority: optional
 Maintainer: Alberto Gonzalez Iniesta <agi@inittab.org>
-Build-Depends: debhelper (>= 13), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre3-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev, pkg-config
+Build-Depends: debhelper (>= 13), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre2-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev, pkg-config
 Standards-Version: 4.6.1
 Section: libs
 Uploaders: Ervin Hegedus <airween@gmail.com>

## modsecurity 3.0.10

=== debian/changelog ===
modsecurity (3.0.10-1) unstable; urgency=medium

  * Team upload
  * New upstream version 3.0.10
    Fixes DoS CVE-2023-38285. (Closes: #1042475)

 -- Ervin Hegedüs <airween@gmail.com>  Sat, 29 Jul 2023 16:42:28 +0200

## modsecurity 3.0.11

=== debian/changelog ===
modsecurity (3.0.11-1) unstable; urgency=medium

  * Team upload
  * New upstream version 3.0.11
  * Add libpcre2-8 to patches/ftbfs_1034760.patch, it has modified in upstream

 -- Ervin Hegedüs <airween@gmail.com>  Thu, 07 Dec 2023 18:28:36 +0100

## modsecurity 3.0.12

=== others/libinjection/Makefile ===

SUBDIRS=src

all:  ## build c library
	(cd src; ${MAKE} all)
check:  ## run tests
	(cd src; ${MAKE} check)
clean:  ## clean up
	@(cd src; ${MAKE} clean)
	git gc --aggressive

.PHONY: all check clean

docker-console:  ## log into the docker test image
	docker run --rm -it \
		-e COVERALLS_REPO_TOKEN=$COVERALLS_REPO_TOKEN \
		-v $(PWD):/build \
		-w /build \
		nickg/libinjection-docker \
		sh

docker-ci:   ## run the tests in docker, as travis-ci does
	docker run --rm \
		-e COVERALLS_REPO_TOKEN=$COVERALLS_REPO_TOKEN \
		-v $(PWD):/build \
		-w /build \
		nickg/libinjection-docker \
		./make-ci.sh

# https://www.client9.com/self-documenting-makefiles/
help:
	@grep -E '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}'
.PHONY: help
.DEFAULT_GOAL := help

=== debian/changelog ===
modsecurity (3.0.12-1.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:07:53 +0000

modsecurity (3.0.12-1.1build1) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:10:28 +0000

modsecurity (3.0.12-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062944

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 20:12:49 +0000

modsecurity (3.0.12-1) unstable; urgency=medium

  * Team upload
  * New upstream version 3.0.12
    Fixes CVE-2024-1019

 -- Ervin Hegedüs <airween@gmail.com>  Tue, 30 Jan 2024 22:45:39 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: modsecurity
 Priority: optional
-Maintainer: Alberto Gonzalez Iniesta <agi@inittab.org>
-Build-Depends: debhelper (>= 13), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre2-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev, pkg-config
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Alberto Gonzalez Iniesta <agi@inittab.org>
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 13), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre2-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev, pkg-config
 Standards-Version: 4.6.1
 Section: libs
 Uploaders: Ervin Hegedus <airween@gmail.com>
@@ -12,7 +13,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmodsecurity3 (= ${binary:Version}), ${misc:Depends}
+Depends: libmodsecurity3t64 (= ${binary:Version}), ${misc:Depends}
 Description: ModSecurity v3 library component (development files)
  Libmodsecurity is one component of the ModSecurity v3 project. The library
  codebase serves as an interface to ModSecurity Connectors taking in web
@@ -23,7 +24,10 @@
  .
  This package includes the development support files.
 
-Package: libmodsecurity3
+Package: libmodsecurity3t64
+Provides: ${t64:Provides}
+Replaces: libmodsecurity3
+Breaks: libmodsecurity3 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/SpiderLabs/ModSecurity/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## modsecurity 3.0.13

=== build/win32/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24)

set(BASE_DIR ${CMAKE_CURRENT_LIST_DIR}/../..)

option(WITH_LMDB    "Include LMDB support"    OFF)
option(WITH_LUA     "Include LUA support"     ON)
option(WITH_LIBXML2 "Include LibXML2 support" ON)
option(WITH_MAXMIND "Include MaxMind support" ON)
option(WITH_CURL    "Include CURL support"    ON)

option(USE_ASAN     "Build with Address Sanitizer" OFF)

# common compiler settings

# NOTE: MBEDTLS_CONFIG_FILE is not only required to compile the mbedtls subset in others, but also
# when their headers are included while compiling libModSecurity
add_compile_definitions(WIN32 _CRT_SECURE_NO_WARNINGS MBEDTLS_CONFIG_FILE="mbedtls/mbedtls_config.h")

# set standards conformance preprocessor & compiler to align with cross-compiled codebase
# NOTE: otherwise visual c++'s default compiler/preprocessor behaviour generates C4067 warnings
# (unexpected tokens following preprocessor directive - expected a newline)
add_compile_options(/Zc:preprocessor /permissive-)

if(USE_ASAN)
  add_compile_options(/fsanitize=address)
  add_link_options(/INFERASANLIBS /INCREMENTAL:no)
endif()

# libinjection

project(libinjection C)

set(LIBINJECTION_DIR ${BASE_DIR}/others/libinjection)

add_library(libinjection STATIC ${LIBINJECTION_DIR}/src/libinjection_sqli.c ${LIBINJECTION_DIR}/src/libinjection_xss.c ${LIBINJECTION_DIR}/src/libinjection_html5.c)

# get libinjection version with git describe
execute_process(
    COMMAND git describe
    WORKING_DIRECTORY ${LIBINJECTION_DIR}
    OUTPUT_VARIABLE LIBINJECTION_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

message("-- Detecting libinjection version - ${LIBINJECTION_VERSION}")

target_compile_definitions(libinjection PRIVATE LIBINJECTION_VERSION="${LIBINJECTION_VERSION}")

# mbedtls (mbedcrypto)

project(mbedcrypto C)

set(MBEDTLS_DIR ${BASE_DIR}/others/mbedtls)

add_library(mbedcrypto STATIC ${MBEDTLS_DIR}/library/base64.c ${MBEDTLS_DIR}/library/sha1.c ${MBEDTLS_DIR}/library/md5.c ${MBEDTLS_DIR}/library/platform_util.c ${MBEDTLS_DIR}/library/constant_time.c)

target_include_directories(mbedcrypto PRIVATE ${MBEDTLS_DIR}/include)

# get mbedtls version with git describe
execute_process(
    COMMAND git describe
    WORKING_DIRECTORY ${MBEDTLS_DIR}
    OUTPUT_VARIABLE MBEDTLS_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

message("-- Detecting Mbed TLS version - ${MBEDTLS_VERSION}")

#
# libModSecurity
#

project(libModSecurity
    VERSION
        3.0.12
    LANGUAGES
        CXX
)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED On)
set(CMAKE_CXX_EXTENSIONS Off)

set(PACKAGE_BUGREPORT "security@modsecurity.org")
set(PACKAGE_NAME "modsecurity")
set(PACKAGE_VERSION "${PROJECT_VERSION}")
set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
set(PACKAGE_TARNAME "${PACKAGE_NAME}")

set(HAVE_YAJL     1)    # should always be one, mandatory dependency
set(HAVE_GEOIP    0)    # should always be zero, no conan package available
set(HAVE_SSDEEP   0)    # should always be zero, no conan package available

macro(enable_feature flag option)
  if(${option})
    set(${flag} 1)  # ON
  else()
    set(${flag} 0)  # OFF
  endif()
endmacro()

enable_feature(HAVE_LMDB ${WITH_LMDB})
enable_feature(HAVE_LUA ${WITH_LUA})
enable_feature(HAVE_LIBXML2 ${WITH_LIBXML2})
enable_feature(HAVE_MAXMIND ${WITH_MAXMIND})
enable_feature(HAVE_CURL ${WITH_CURL})

include(${CMAKE_CURRENT_LIST_DIR}/ConfigureChecks.cmake)

configure_file(config.h.cmake ${BASE_DIR}/src/config.h)

find_package(PCRE2 REQUIRED)
find_package(Poco REQUIRED)
find_package(dirent REQUIRED)		# used only by tests (check dirent::dirent refernces)

macro(include_package package flag)
  if(${flag})
    find_package(${package} REQUIRED)
  endif()
endmacro()

include_package(yajl HAVE_YAJL)
include_package(libxml2 HAVE_LIBXML2)
include_package(lua HAVE_LUA)
include_package(CURL HAVE_CURL)
include_package(lmdb HAVE_LMDB)
include_package(maxminddb HAVE_MAXMIND)

# library
#

# NOTE: required to generate libModSecurity's import library (libModSecurity.lib), used by tests to link with shared library
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

file(GLOB_RECURSE libModSecuritySources ${BASE_DIR}/src/*.cc)

add_library(libModSecurity SHARED ${libModSecuritySources})

target_compile_definitions(libModSecurity PRIVATE WITH_PCRE2)
target_include_directories(libModSecurity PRIVATE ${BASE_DIR} ${BASE_DIR}/headers ${BASE_DIR}/others ${MBEDTLS_DIR}/include)
target_link_libraries(libModSecurity PRIVATE pcre2::pcre2 libinjection mbedcrypto Poco::Poco Iphlpapi.lib)

macro(add_package_dependency project compile_definition link_library flag)
  if(${flag})
    target_compile_definitions(${project} PRIVATE ${compile_definition})
    target_link_libraries(${project} PRIVATE ${link_library})
  endif()
endmacro()

add_package_dependency(libModSecurity WITH_YAJL yajl::yajl HAVE_YAJL)
add_package_dependency(libModSecurity WITH_LIBXML2 LibXml2::LibXml2 HAVE_LIBXML2)
add_package_dependency(libModSecurity WITH_LUA lua::lua HAVE_LUA)
if(HAVE_LUA)
  target_compile_definitions(libModSecurity PRIVATE WITH_LUA_5_4)
endif()
add_package_dependency(libModSecurity MSC_WITH_CURL CURL::libcurl HAVE_CURL)
add_package_dependency(libModSecurity WITH_LMDB lmdb::lmdb HAVE_LMDB)
add_package_dependency(libModSecurity WITH_MAXMIND maxminddb::maxminddb HAVE_MAXMIND)

# tests
#

project(libModSecurityTests)

function(setTestTargetProperties executable)
  target_compile_definitions(${executable} PRIVATE WITH_PCRE2)
  target_include_directories(${executable} PRIVATE ${BASE_DIR} ${BASE_DIR}/headers)
  target_link_libraries(${executable} PRIVATE libModSecurity pcre2::pcre2 dirent::dirent)
  add_package_dependency(${executable} WITH_YAJL yajl::yajl HAVE_YAJL)
endfunction()

# unit tests
file(GLOB unitTestSources ${BASE_DIR}/test/unit/*.cc)
add_executable(unit_tests ${unitTestSources})
setTestTargetProperties(unit_tests)
target_compile_options(unit_tests PRIVATE /wd4805)

# regression tests
file(GLOB regressionTestsSources ${BASE_DIR}/test/regression/*.cc)
add_executable(regression_tests ${regressionTestsSources})
setTestTargetProperties(regression_tests)

macro(add_regression_test_capability compile_definition flag)
  if(${flag})
    target_compile_definitions(regression_tests PRIVATE ${compile_definition})
  endif()
endmacro()

add_regression_test_capability(WITH_LUA HAVE_LUA)
add_regression_test_capability(WITH_CURL HAVE_CURL)
add_regression_test_capability(WITH_LMDB HAVE_LMDB)
add_regression_test_capability(WITH_MAXMIND HAVE_MAXMIND)

enable_testing()

file(READ ${BASE_DIR}/test/test-suite.in TEST_FILES_RAW)
string(REPLACE "\n" ";" TEST_FILES ${TEST_FILES_RAW})

foreach(TEST_FILE ${TEST_FILES})
  # ignore comment lines
  string(FIND ${TEST_FILE} "#" is_comment)
  if(NOT is_comment EQUAL 0)
    string(FIND ${TEST_FILE} "TESTS+=" is_valid_prefix)
    if(NOT is_valid_prefix EQUAL 0)
      message(FATAL_ERROR "Invalid prefix in line: ${TEST_FILE}")
    endif()

    # remove 'TESTS+=' prefix and 'test/' too because tests are launched
    # from that directory
    string(SUBSTRING ${TEST_FILE} 12 -1 TEST_FILE)

    # test name
    get_filename_component(TEST_NAME ${TEST_FILE} NAME_WE)

    # determine test runner based on test path prefix
    string(FIND ${TEST_FILE} "test-cases/regression/" is_regression_test)
    if(is_regression_test EQUAL 0)
        set(TEST_RUNNER "regression_tests")
    else()
        set(TEST_RUNNER "unit_tests")
    endif()

    add_test(NAME ${TEST_NAME} COMMAND ${TEST_RUNNER} ${TEST_FILE} WORKING_DIRECTORY ${BASE_DIR}/test)
  endif()
endforeach()

# benchmark
add_executable(benchmark ${BASE_DIR}/test/benchmark/benchmark.cc)
setTestTargetProperties(benchmark)

# rules_optimization
add_executable(rules_optimization ${BASE_DIR}/test/optimization/optimization.cc)
setTestTargetProperties(rules_optimization)


# examples
#

project(libModSecurityExamples)

function(setExampleTargetProperties executable)
  target_include_directories(${executable} PRIVATE ${BASE_DIR} ${BASE_DIR}/headers)
  target_link_libraries(${executable} PRIVATE libModSecurity)
endfunction()

# simple_example_using_c
add_executable(simple_example_using_c ${BASE_DIR}/examples/simple_example_using_c/test.c)
setExampleTargetProperties(simple_example_using_c)

# using_bodies_in_chunks
add_executable(using_bodies_in_chunks ${BASE_DIR}/examples/using_bodies_in_chunks/simple_request.cc)
setExampleTargetProperties(using_bodies_in_chunks)

# reading_logs_via_rule_message
add_executable(reading_logs_via_rule_message ${BASE_DIR}/examples/reading_logs_via_rule_message/simple_request.cc)
setExampleTargetProperties(reading_logs_via_rule_message)

# reading_logs_with_offset
add_executable(reading_logs_with_offset ${BASE_DIR}/examples/reading_logs_with_offset/read.cc)
setExampleTargetProperties(reading_logs_with_offset)

# multithread
add_executable(multithread ${BASE_DIR}/examples/multithread/multithread.cc)
setExampleTargetProperties(multithread)

# tools
#

# rules_check
add_executable(rules_check ${BASE_DIR}/tools/rules-check/rules-check.cc)
target_include_directories(rules_check PRIVATE ${BASE_DIR} ${BASE_DIR}/headers)
target_link_libraries(rules_check PRIVATE libModSecurity)

=== others/mbedtls/programs/test/cmake_subproject/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)

# Test the target renaming support by adding a prefix to the targets built
set(MBEDTLS_TARGET_PREFIX subproject_test_)

# We use the parent Mbed TLS directory as the MBEDTLS_DIR for this test. Other
# projects that use Mbed TLS as a subproject are likely to add by their own
# relative paths.
set(MBEDTLS_DIR ../../../)

# Add Mbed TLS as a subdirectory.
add_subdirectory(${MBEDTLS_DIR} build)

# Link against all the Mbed TLS libraries. Verifies that the targets have been
# created using the specified prefix
set(libs
    subproject_test_mbedcrypto
    subproject_test_mbedx509
    subproject_test_mbedtls
)

add_executable(cmake_subproject cmake_subproject.c)
target_link_libraries(cmake_subproject ${libs} ${CMAKE_THREAD_LIBS_INIT})

=== debian/changelog ===
modsecurity (3.0.13-1) unstable; urgency=medium

  * New upstream version 3.0.13
  * Removed d/compat file
  * Added "debhelper-compat" to Build-Dep in d/control
  * Changed pkg-config to pkgconf in d/control

 -- Ervin Hegedüs <airween@gmail.com>  Thu, 05 Sep 2024 11:26:32 +0200

modsecurity (3.0.12-2) UNRELEASED; urgency=medium

  * Acknowledge NMU by Benjamin Drung. Thanks!

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Mon, 08 Apr 2024 13:14:42 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: modsecurity
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Alberto Gonzalez Iniesta <agi@inittab.org>
-Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 13), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre2-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev, pkg-config
+Maintainer: Alberto Gonzalez Iniesta <agi@inittab.org>
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 13), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre2-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev, pkgconf, debhelper-compat (= 13)
 Standards-Version: 4.6.1
 Section: libs
 Uploaders: Ervin Hegedus <airween@gmail.com>
